unit FMMain;

interface

{
  migeel's Private Floppy (aka FloppyStore)
  Copyright (c) 2003-2004, Michal Strehovsky
  www.migeel.sk
  Comments? -> mail@migeel.sk
               ICQ: 140294388

  This program is released under the terms of MIT license.
  See help for more information.
  In short: MIT license allows you to modify this source,
  but you must keep my copyright somewhere...
  And it would be great if you send me an e-mail about
  your modifications.

  If you think that this source sucks, delete it
  immediately!
}


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ImgList, ComCtrls, wcimgcbo, Buttons, HintShadow, Menus,
  ToolWin, ShellApi;

type
  TMain = class(TForm)
    Content: TListView;
    DataImages: TImageList;
    DataType: TImageComboBox;
    edValue: TEdit;
    edData: TEdit;
    btnRefresh: TBitBtn;
    btnRemove: TBitBtn;
    btnNew: TBitBtn;
    ToolBar: TToolBar;
    Menu: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    LoadfromFloppy1: TMenuItem;
    SavetoFloppy1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar: TStatusBar;
    Save: TToolButton;
    MenuImages: TImageList;
    ToolButton1: TToolButton;
    Load: TToolButton;
    ToolButton2: TToolButton;
    Help: TToolButton;
    About1: TMenuItem;
    Help2: TMenuItem;
    procedure LoadData(Data: string);
    function SaveData:string;
    procedure DisableUI(Enable: boolean);
    procedure FormCreate(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure ContentSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

const
  LVM_FIRST                     = $1000;
  LVM_SETEXTENDEDLISTVIEWSTYLE  = LVM_FIRST + 54;
  LVS_EX_INFOTIP                = $00000400;
  LVM_GETTOOLTIPS               = LVM_FIRST + 78;
  TTM_SETDELAYTIME              = WM_USER + 3;
  TTDT_AUTOMATIC                = 0;
  TTDT_AUTOPOP                  = 2;

resourcestring
  ENoFloppy    = 'Please insert a floppy.';
  EReadError   = 'Read error';
  EWriteError  = 'Write error';
  MDiskSpace   = 'Not enough free space on the floppy!';
  MUsedFree    = '%d bytes used, %d bytes free.';
  MNew         = 'New';
  MRequest     = 'Requires Windows NT/2000/XP or higher.';
  MInformation = 'Information';
  Floppy       = '\\.\A:';

{$R *.DFM}

function OpenFloppy(AccessMode: DWORD):DWORD;
begin
  Result:=CreateFileA(PChar(Floppy),AccessMode,FILE_SHARE_WRITE,nil,OPEN_EXISTING,0,0);
  if Result=INVALID_HANDLE_VALUE then
     Sleep(500)
  else
      exit;

  // Second attempt (is successfull sometimes)
  Result:=CreateFileA(PChar(Floppy),AccessMode,FILE_SHARE_WRITE,nil,OPEN_EXISTING,0,0);
end;

function SaveDataToBootSector(Data: string):boolean;
const SectorZeroData: array [1..63] of byte =
  ($EB,$3C,$90,$4D,$53,$44,$4F,$53,$35,$2E,$30,$00,$02,$01,$01,$00,
   $02,$E0,$00,$40,$0B,$F0,$09,$00,$12,$00,$02,$00,$00,$00,$00,$00,
   $00,$00,$00,$00,$00,$00,$29,$4A,$6E,$8C,$AC,$4E,$4F,$20,$4E,$41,
   $4D,$45,$20,$20,$20,$20,$46,$41,$54,$31,$32,$20,$20,$20,$F4{=HLT:stops CPU});
var h: THandle;
    Buffer: array[1..512] of byte;
    i: integer;
begin
  // We have to write the first 512 bytes, because
  // count passed to WriteFile must be dividable by 512
  // what is the size of a floppy sector.
  result:=false;

  if Length(Data)>512-65 then
  begin
    MessageBox(Main.Handle,PChar(MDiskSpace),PChar(EWriteError),MB_ICONHAND);
    exit;
  end;

  if Length(Data)<(512-65) then
     for i:=Length(Data) to (512-65) do Data:=Data+#0;

  // Build up Sector 0
  CopyMemory(@Buffer[1],@SectorZeroData[1],SizeOf(SectorZeroData));
  CopyMemory(@Buffer[64],@Data[1],Length(Data));
  Buffer[511]:=$55; Buffer[512]:=$AA;
  // New Sector 0 is ready

  // Open floppy (RAW access) - works only under NT/2000/XP
  // what a shame!
  h:=OpenFloppy(GENERIC_WRITE);
  if h=INVALID_HANDLE_VALUE then
  begin
    MessageBox(Main.Handle,PChar(ENoFloppy),PChar(EWriteError),MB_ICONHAND);
    exit;
  end;
  FileWrite(h,Buffer,512);
  FileClose(h);
end;

function LoadDataFromBootSector:string;
var Buffer: array[1..512] of char;
    h: THandle;
    i: integer;
    ZeroFound: boolean;
begin
  result:='';
  h:=OpenFloppy(GENERIC_READ);
  if h=INVALID_HANDLE_VALUE then
  begin
    MessageBox(Main.Handle,PChar(ENoFloppy),PChar(EReadError),MB_ICONHAND);
    exit;
  end;

  FileRead(h,Buffer,512);
  FileClose(h);

  if Buffer[63]<>#$F4 then exit;

  ZeroFound:=False;
  // Look for $00, $00 sequence
  for i:=64 to 512 do
  begin
    Result:=Result+Buffer[i];
    if Buffer[i]=#0 then
    begin
      if not ZeroFound then ZeroFound:=true
      else
          break;
    end
    else
        ZeroFound:=false;
  end;
end;

procedure TMain.LoadData(Data: string);
var Temp: string;
    Texts: array [1..256] of string;
    indexes: array [1..128] of byte;
    count: byte;
    i: integer;
    NewItem: TListItem;
begin
  Content.Items.Clear;

  Temp:=''; count:=0;
  for i:=1 to length(Data) do
  begin
    if Ord(Data[i])<5 then
    begin
      if Data[i]=#0 then
      begin
        if Length(Temp)=0 then break; // two zeroes - END
        inc(Count);
        Texts[Count]:=temp;
        Temp:='';
      end;
      if Data[i] in [#1,#2,#3,#4] then
      begin
        if Length(Temp)>0 then
        begin
          inc(Count);
          Texts[Count]:=temp;
          Temp:='';
        end;
        indexes[(Count div 2)+1]:=Ord(Data[i])-1;
      end;
    end
    else
        Temp:=Temp+Data[i];
  end;

  for i:=1 to Count div 2 do
  begin
    NewItem:=Content.Items.Add;
    NewItem.Caption:=Texts[i*2-1];
    NewItem.SubItems.Add(Texts[i*2]);
    NewItem.ImageIndex:=indexes[i];
  end;

end;

function TMain.SaveData: string;
var i: integer;
begin
  result:='';
  if Content.Items.Count=0 then exit;
  for i:=0 to Content.Items.Count-1 do
  begin
    result:=result+Chr(Content.Items[i].ImageIndex+1);
    result:=result+Content.Items[i].Caption;
    result:=result+#0+Content.Items[i].SubItems[0];
  end;
  result:=result+#0#0;
end;

procedure TMain.FormCreate(Sender: TObject);
var ToolTipHandle: hWnd;
begin
  if Win32Platform<>VER_PLATFORM_WIN32_NT then
     MessageBox(Handle,PChar(MRequest),PChar(MInformation),MB_ICONINFORMATION);
  DataType.ItemIndex:=0;
  DisableUI(false);

  // this will popup text in a hint window, if text
  // exceeds visible area in Content
  // Just type in a long text, update it in the content window
  // and move the mouse over it to see the effect...
  SendMessage(Content.Handle,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_INFOTIP,LVS_EX_INFOTIP);
  ToolTipHandle:=SendMessage(Content.Handle,LVM_GETTOOLTIPS,0,0);
  SendMessage(ToolTipHandle,TTM_SETDELAYTIME,TTDT_AUTOMATIC,1);
  SendMessage(ToolTipHandle,TTM_SETDELAYTIME,TTDT_AUTOPOP,5000);
end;

procedure TMain.btnNewClick(Sender: TObject);
var NewItem: TListItem;
begin
  NewItem:=Content.Items.Add;
  NewItem.ImageIndex:=0;
  NewItem.Caption:=MNew;
  NewItem.SubItems.Add('');
  Content.Selected:=NewItem;
end;

procedure TMain.ContentSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  StatusBar.SimpleText:=Format(MUsedFree,
    [Length(SaveData),512-65-Length(SaveData)]);

  if Content.Selected=nil then
  begin
    DataType.ItemIndex:=0;
    edValue.Text:='';
    edData.Text:='';
    DisableUI(false);
    exit;
  end;

  DisableUI(true);
  DataType.ItemIndex:=Content.Selected.ImageIndex;
  edValue.Text:=Content.Selected.Caption;
  edData.Text:=Content.Selected.SubItems[0];
end;

procedure TMain.btnRefreshClick(Sender: TObject);
begin
  if Content.Selected=nil then
     btnNewClick(nil);

  with Content.Selected do
  begin
    Caption:=edValue.Text;
    SubItems[0]:=edData.Text;
    ImageIndex:=DataType.ItemIndex;
  end;

  Content.Selected:=nil;
end;

procedure TMain.btnRemoveClick(Sender: TObject);
begin
  if Content.Selected<>nil then
     Content.Items.Delete(Content.Selected.Index);
end;

procedure TMain.DisableUI(Enable: boolean);
begin
  DataType.Enabled:=Enable;
  edValue.Enabled:=Enable;
  edData.Enabled:=Enable;
end;

procedure TMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMain.SaveClick(Sender: TObject);
begin
  SaveDataToBootSector(SaveData);
end;

procedure TMain.LoadClick(Sender: TObject);
begin
  LoadData(LoadDataFromBootSector);
  ContentSelectItem(nil,nil,false); // show bytes used and bytes free
end;

procedure TMain.About1Click(Sender: TObject);
begin
  MessageBox(Handle,
    'Private Floppy'+#13+
    'Copyright (c) 2003-2004 Michal Strehovsky'+#13+
    'www.migeel.sk'#13+#13+
    'Released under the terms of MIT license.',
    'About Private Floppy...',MB_ICONINFORMATION);
end;

procedure TMain.Help2Click(Sender: TObject);
begin
  ShellExecuteA(Handle,'open','PrivateFloppy.chm',nil,nil,SW_SHOW);
end;

end.
